local Mission = {}

Mission.displayName = "The Drill"

Mission.mapName = "testmap1"

Mission.description = getString( "mission_description_1" )


-- no parameters
function Mission.onGameStart()
	print( "mission 1 started" )
	
	-- create a tool store
	do
		local building = Game:spawnBuilding( ENTITIES.toolStore, 6, 2 )
		
		local x, y = building:getPosition()
		Camera:setPosition( x, y )
		
	end
	
	-- test: create a teleport pad
	Game:spawnBuilding( ENTITIES.teleportPad, 7, 2 )
	
	Game:spawnBuilding( ENTITIES.powerStation, 6, 3 )
	
	-- test: create a vehicle
	do
		local xi = 6
		local yi = 3
		-- EntityManager:createEntity( ENTITIES.transportTruck, { x = 785, y = 320 } )
		EntityManager:createEntity( ENTITIES.digger, { x = 785, y = 320 } )
		-- EntityManager:createEntity( ENTITIES.loaderDozer, { x = 785, y = 320 } )
		-- EntityManager:createEntity( ENTITIES.mobileLaserCutter, { x = 775, y = 320 } )
		-- EntityManager:createEntity( ENTITIES.hoverScout, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE } )
	end
	
	-- test: create a building in a different cave
	Game:spawnBuilding( ENTITIES.vehicleFactory, 2, 7 )
	Game:spawnBuilding( ENTITIES.robotBay, 3, 7 )
	-- Game:spawnBuilding( ENTITIES.toolStore, 3, 7 )
	
	-- test: create a defensive building
	local tesla = Game:spawnBuilding( ENTITIES.teslaTower, 6, 4 )
	
	-- hurt a building
	-- Game:onEntityHurtEntity( nil, tesla, 20 )
	
	
	-- test: create a fledder
	EntityManager:createEntity( ENTITIES.fledder, { x = 6 * TILESIZE, y = 2 * TILESIZE } )
	-- EntityManager:createEntity( ENTITIES.fledder, { x = 5 * TILESIZE+10, y = 5 * TILESIZE-10 } )
	
	
	-- mob spawn settings
	local spawner = Game.mobSpawner
	-- value must be in range 0-1
	-- spawner:setMobSpawnChance( ENTITIES.fledder, 0.8 )
	-- spawner:disableMobSpawning()
	
	-- spawn a mob
	-- EntityManager:createEntity( ENTITIES.rockMonster, { x = 590, y = 760 } )
	
	-- EntityManager:createEntity( ENTITIES.rockRaider, { x = 700, y = 760 } )
	
	
	-- victory condition
	Game:trackJob( Simplejob:addJob{
		intervall = 1,
		callback = function()
			if GUImgr:getCurrentScreenId() ~= Game.id then
				return true
			end
			if Game.isPaused then return end
			
			if Mission.checkVictoryCondition() then
				Game:victory()
				return true
			end
		end,
	} )
	
end


function Mission.checkVictoryCondition()
	-- test only: collect 10 rock samples to win this mission
	return Game:getPlayerGlobalResource( ENTITIES.rockSample ) >= 10
end


function Mission.onEntityCreated( entity )
	
end


function Mission.onEntityHurtEntity( event )
	
end


-- called after the wall is removed
-- params: entityId, xi and yi tile index
--> the wall with the given entityId does not exist anymore (but maybe the ID is of interest...)
function Mission.onWallDestroyed( entityId, xi, yi )
	
end


-- called before the debris is finally removed
-- params: entity, xi and yi tile index
function Mission.onBeforeDebrisRemoved( debris, xi, yi )
	
	-- test: create a rock sample sometimes
	-- only if the debris does can contain ore (that is, it was created after drilling a wall)
	if not debris.doNotContainOre and math.random() < 0.5 then
		local x, y = tileIndexToPosition( xi, yi )
		EntityManager:createEntity( ENTITIES.rockSample, { x = x, y = y } )
	end
	
end


return Mission
