local CreateRandomBag = {}
local random = math.random

function CreateRandomBag:create()
	local rb = { items = {}, sum = 0 }
	
	function rb:add(item, weight)
		self.sum = self.sum + weight
		table.insert(self.items, { object = item, weightedSum = self.sum })
	end
	
	function rb:getRandom()
		local randi = random(1, self.sum)
		for i = 1, #self.items do
			if self.items[i].weightedSum >= randi then
				return self.items[i].object
			end
		end
		return false
	end
	
	function rb:clear()
		self.items = {}
		self.sum = 0
	end
	
	return rb
end

return CreateRandomBag
