
TILESIZE = 125

ENTITIES = {
	hardRock = 1,
	solidRock = 2,
	looseRock = 3,
	debris = 4,
	toolStore = 5,
	rockRaider = 6,
	ore = 7,
	teleportPad = 8,
	energyCrystal = 9,
	constructionSite = 10,
	hoverScout = 11,
	digger = 12,
	constructionFence = 13,
	transportTruck = 14,
	robotBay = 15,
	vehicleFactory = 16,
	landslide = 17,
	teslaTower = 18,
	fledder = 19,
	teslaBolt = 20,
	waterGunTower = 21,
	probeDroid = 22,
	mobileLaserCutter = 23,
	supportStation = 24,
	carl = 25,
	rockSample = 26,
	buildingArea = 27,
	powerStation = 28,
	loaderDozer = 29,
	rockMonster = 30,
}

function GetEntityTypeName( entityType )
	for k, v in pairs(ENTITIES) do
		if v == entityType then
			return k
		end
	end
end


ENTITYCATEGORY = {
	wall = 1,
	debris = 2,
	building = 3,
	buildingArea = 4,
	buildingOther = 5,
	rockRaider = 6,
	resource = 7,
	vehicle = 8,
	landslide = 9,
	monster = 10,
	projectile = 11,
	robot = 12,
}

COSTS = {}
COSTS.entities = {
	-- building costs
	[ENTITIES.buildingArea] = { [ENTITIES.ore] = 2 },
	[ENTITIES.toolStore] = { [ENTITIES.ore] = 5 },
	[ENTITIES.teleportPad] = { [ENTITIES.ore] = 6, [ENTITIES.energyCrystal] = 1 },
	[ENTITIES.powerStation] = { [ENTITIES.ore] = 12, [ENTITIES.energyCrystal] = 2 },
	[ENTITIES.robotBay] = { [ENTITIES.ore] = 15, [ENTITIES.energyCrystal] = 2 },
	[ENTITIES.vehicleFactory] = { [ENTITIES.ore] = 12, [ENTITIES.energyCrystal] = 2 },
	[ENTITIES.teslaTower] = { [ENTITIES.ore] = 15, [ENTITIES.energyCrystal] = 1 },
	[ENTITIES.waterGunTower] = { [ENTITIES.ore] = 15, [ENTITIES.energyCrystal] = 1 },
	[ENTITIES.supportStation] = { [ENTITIES.ore] = 15, [ENTITIES.energyCrystal] = 3 },
	
	-- unit costs
	[ENTITIES.digger] = { [ENTITIES.energyCrystal] = 1 },
	[ENTITIES.hoverScout] = { [ENTITIES.energyCrystal] = 1 },
	[ENTITIES.transportTruck] = { [ENTITIES.energyCrystal] = 1 },
	[ENTITIES.mobileLaserCutter] = { [ENTITIES.energyCrystal] = 1 },
	[ENTITIES.loaderDozer] = { [ENTITIES.energyCrystal] = 1 },
	[ENTITIES.probeDroid] = { [ENTITIES.energyCrystal] = 1 },
}

COSTS.buildingUpgrades = {
	-- (building) upgrade costs
	[ENTITIES.toolStore] = {
		-- 1st upgrade
		{ [ENTITIES.ore] = 5 },
		-- 2nd upgrade
		{ [ENTITIES.ore] = 5 },
	},
	[ENTITIES.teleportPad] = {
		{ [ENTITIES.ore] = 5 },
	},
	[ENTITIES.powerStation] = {
		{ [ENTITIES.ore] = 5 },
	},
	[ENTITIES.supportStation] = {
		{ [ENTITIES.ore] = 5 },
		{ [ENTITIES.ore] = 5 },
	},
	[ENTITIES.vehicleFactory] = {
		{ [ENTITIES.ore] = 5 },
		{ [ENTITIES.ore] = 5 },
	},
	[ENTITIES.robotBay] = {
		{ [ENTITIES.ore] = 5 },
		{ [ENTITIES.ore] = 5 },
	},
}

COSTS.entityUpgrades = {
	["drill_efficiency"] = { [ENTITIES.ore] = 5 },
	["movement_speed"] = { [ENTITIES.ore] = 5 },
	["cargo_capacity"] = { [ENTITIES.ore] = 5 },
}

COSTS.research = {
	-- research costs
}
